
// SampleChartDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SampleChart.h"
#include "SampleChartDlg.h"
#include "afxdialogex.h"
#include "StGisCommands.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CSampleChartDlg dialog



CSampleChartDlg::CSampleChartDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CSampleChartDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSampleChartDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CSampleChartDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_MESSAGE(MSG_UPDATE_ANALYZER, OnUpdateAnalyzerNotify)
	ON_MESSAGE(MSG_UPDATE_GRAPH, OnUpdateGraphNotify)
	ON_MESSAGE(MSG_UPDATE_TEXT, OnUpdateTextNotify)
END_MESSAGE_MAP()


// CSampleChartDlg message handlers

BOOL CSampleChartDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	theApp.CreateGraphThreads();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSampleChartDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSampleChartDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSampleChartDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

LRESULT  CSampleChartDlg::OnUpdateAnalyzerNotify(WPARAM wParam, LPARAM lParam)
{
	std::auto_ptr<CStGIS_AnalyzerData> packet{ reinterpret_cast<CStGIS_AnalyzerData*>(lParam) };
	manager_.HandleAnalyzerWndSpecificFunc(packet);
	::Sleep(5);
	::Sleep(0);

	return 0L;
}



//////////////////////////////////////////////////////////////////////////////////////
////// 

LRESULT CSampleChartDlg::OnUpdateGraphNotify(WPARAM wParam, LPARAM lParam)
{
	std::auto_ptr<CStGIS_GraphData> packet{ reinterpret_cast<CStGIS_GraphData*>(lParam) };
	manager_.HandleGraphSpecificFunc(packet);
	::Sleep(5);
	::Sleep(0);

	return 0L;

}

//////////////////////////////////////////////////////////////////////////////////////
////// 

LRESULT CSampleChartDlg::OnUpdateTextNotify(WPARAM wParam, LPARAM lParam)
{
	std::auto_ptr<CStGIS_TextData> packet{ reinterpret_cast<CStGIS_TextData*>(lParam) };
	manager_.HandleTextSpecificFunc(packet);
	::Sleep(5);
	::Sleep(0);

	return 0L;
}


