#pragma once

////#include "Sagi.Core Data/realtimedata.h"
////#include "datatypes.h"
////#include "ResizeCtrl.h"
#include "Chartwrapper.h"
#include "tchart.h"
#include <vector>
#include <afxtempl.h>
#include <deque>
#include <map>

#define ONED_LEFT 5
#define ONED_TOP 10
#define RESOURCEID_CONSTANT 2003


static const UINT UWM_RESET_DLG_CONTENT = WM_USER + 1000;
static const UINT UWM_ENABLE_MENU_ITEM = UWM_RESET_DLG_CONTENT + 1;
static const UINT UWM_PLOT_GIS_TEXT = UWM_ENABLE_MENU_ITEM + 1;
static const UINT UWM_CALL_GRAPH_FUNCTION = UWM_PLOT_GIS_TEXT + 1;
static const UINT UWM_REMOVE_ANALYZER_WND = UWM_CALL_GRAPH_FUNCTION + 1;
static const UINT UWM_CREATE_SUB_WINDOW = UWM_REMOVE_ANALYZER_WND + 1;
static const UINT UWM_SET_CLOSE_MODE = UWM_CREATE_SUB_WINDOW + 1;
static const UINT UWM_PROCESS_ANALYZER_WND_FUNC = UWM_SET_CLOSE_MODE + 1;
static const UINT WM_SET_DIALOG_MENU = UWM_PROCESS_ANALYZER_WND_FUNC + 1;
static const UINT UWM_REMOVE_ANALYZER_THREAD = WM_SET_DIALOG_MENU + 1;
static const UINT UWM_CREATE_FILE_READER_WRITER_THREAD = UWM_REMOVE_ANALYZER_THREAD + 1;
static const UINT UWM_REPAINT_GRAPH_WND = UWM_CREATE_FILE_READER_WRITER_THREAD + 1;


namespace nsSTAr
{
	namespace nsChartDataType
	{
		typedef std::vector<double> CReal64Vector;
		enum enChartLineStyle;
		enum enChartPointStyle;
	}
}

struct CY1TChartLabels
{
	double x1_;


	CY1TChartLabels() : x1_(0){}
};
struct CY2TChartLabels
{
	double x1_;


	CY2TChartLabels() : x1_(0){}
};
struct CXTChartLabels
{
	double x1_;


	CXTChartLabels() : x1_(0){}
};
struct CTChartLabels
{
	std::deque<CY1TChartLabels>				 Y1Labels;
	std::deque<CY2TChartLabels>				 Y2Labels;
	std::deque<CXTChartLabels>				 XLabels;
};

struct CGraphAxisInfo
{
	int countX_;
	int countY1_;
	int countY2_;
	double lastLabelX_;
	double lastLabelY1_;
	double lastLabelY2_;
};

	// CStAnalyzerDlg dialog

	class CStAnalyzerDlg : public CDialog
	{
		DECLARE_DYNAMIC(CStAnalyzerDlg)
		
	public:
		
		// Dialog data
		enum { IDD = IDD_STREALTIMEANALYZER_WND };
		// data 
		CString m_strTest;
		CString m_strTester;
		int m_nGraphResourceID;
		int m_nTextResourceID;

		BSTR bstrLic;

		std::map<int, CChartWrapper *> m_aMapGrpWndToSequence;

		std::map<int, CEdit*> m_aMapTxtWndToSequence;
		std::vector<HFONT> vec_font_;


		CMap<int, int&, CStringArray*, CStringArray* &> m_aGraphWndToParam;

		CStAnalyzerDlg (LPCTSTR tzTest, LPCTSTR tzTester, CWnd* pParent = NULL);   // standard constructor
		virtual ~CStAnalyzerDlg();
        static int object_count_;
        int text_control_count_, graph_control_count_;
        static const int /*MINX, MINY, ONED_LEFT, ONED_TOP, ONED_RIGHT, ONED_BOTTOM, RIGHT_PAD, BOTTOM_PAD,*/ pad_ , graph_height_, graph_width_, max_no_graph_per_row_;

	protected:
		

		//CChartWrapper* GetGraphWnd(int nSequence);
		//CEdit* GetTxtWnd(int nSequence);
		
		nsSTAr::nsChartDataType::enChartLineStyle GetLineStyle(const int nLineStyle);
		nsSTAr::nsChartDataType::enChartPointStyle GetPointStyle(const int nPointStyle);
		COLORREF GetColor(int nColor);
		void GetTime(CString& strTime);
    private:
        CStLineProperty curr_line_prop_;
        std::map<int,CStLineProperty> map_line_prop_;

		int last_plot_id_;
        int last_seq_;
		int prev_xy_color_;
		int prev_xy2_color_;
        int count_plot_line_;
        int last_plot_line;
		int prevVal_;
		bool is_force_close_;
		
        bool call_plot;
        //std::deque<std::pair<int, CPlot_Data> > deq_plots;
        std::map<int, std::deque<std::pair<int, CPlot_Data> > > map_plots;

		std::map<int, CGraphAxisInfo> map_axisinfo_;

		////afx_msg LRESULT OnSetCloseMode(WPARAM, LPARAM lparam);
		////afx_msg LRESULT OnSetDialogMenu(WPARAM wParam, LPARAM lparam);
		
	public:

		bool CreateSubWindow(int nTextWindow, int nGraphWindow);

		void ResetDialogContent();
		
        ////void Transform(Array1D_Double &Values);
        ////void Transform(Array2D_Double &Values);
        ////void Transform(double &Value);

	protected:

		virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
		DECLARE_MESSAGE_MAP()

	public:

		virtual void PostNcDestroy();
		virtual BOOL OnInitDialog();		
		afx_msg void OnClose();
		afx_msg void OnDestroy();
		//afx_msg void OnExitSizeMove();
		afx_msg LRESULT OnResetDlgContent(WPARAM wParam, LPARAM lParam);
		afx_msg LRESULT OnCreateSubWindow(WPARAM wparam, LPARAM lparam);
		//afx_msg LRESULT OnRepaintGraphWindow(WPARAM wparam, LPARAM lParam);    
private:

        //void PositionGraph(const CRect& );
        void GetDimensions(std::vector<CRect>& vecdimensions, const CRect& windowdimension);
        void GetControlWidth(const CRect &windowdimension, int &width,const int total_wnd_count);
        void GetControlHeight(const CRect &windowdimension, int &height,const int total_wnd_count);
        void GetControlDimension(const CRect &windowdimension, int &graph_width, int &graph_height);

    public:
		afx_msg void OnGetMinMaxInfo(MINMAXINFO* lpMMI);
	

		////std::map<int, CTChart *> map_tchart_;
		std::map<int, CTChartLabels> map_label_;
		std::deque<CY1TChartLabels>::iterator itr_deq1;
		std::deque<CY2TChartLabels>::iterator itr_deq2;
		std::deque<CXTChartLabels>::iterator itr_deq3;

		bool val1_;
		bool val2_;
		bool formatcheck_;

		DECLARE_EVENTSINK_MAP()
		////void OnGetNextAxisLabelTchart1(long Axis, long LabelIndex, double* LabelValue, BOOL* MoreLabels);
		////void OnGetNextAxisLabelTchart2(long Axis, long LabelIndex, double* LabelValue, BOOL* MoreLabels);
		////void OnGetAxisLabelTchart1(long Axis, long SeriesIndex, long ValueIndex, BSTR* LabelText);
		////void OnGetAxisLabelTchart2(long Axis, long SeriesIndex, long ValueIndex, BSTR* LabelText);
};

