// ..\StAnalyzerThread.cpp : implementation file
//

#include "stdafx.h"
#include "SampleChart.h"
#include "StAnalyzerThread.h"
#include "StAnalyzerDlg.h"
#include "StGisCommands.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CStAnalyzerThread

CEvent CStAnalyzerThread::eventDialogCreated_;

IMPLEMENT_DYNCREATE(CStAnalyzerThread, CWinThread)

CStAnalyzerThread::CStAnalyzerThread()
:
strTestName_(""),
strTesterName_(""),
nTextCount_(0),
nGraphCount_(0),
bDialogCreated_(false)
{
}

CStAnalyzerThread::~CStAnalyzerThread()
{
	TRACE("\nDestroying CStAnalyzerThread\n");
}

CStAnalyzerThread* CStAnalyzerThread::CreateAnalyzerThread(const std::string& strTestName, const std::string& strTesterID, int nSizeInPerc, int nTextCount, int nGraphcount, int nResourceID,bool bCreateForeGround)
{
	std::auto_ptr<CStAnalyzerThread> pAnalyzerThread{ dynamic_cast<CStAnalyzerThread*>(AfxBeginThread(RUNTIME_CLASS(CStAnalyzerThread), THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED)) };

	if (!pAnalyzerThread.get()) {
		throw;
	}

	pAnalyzerThread->m_bAutoDelete = FALSE;
	pAnalyzerThread->strTestName_ = strTestName;
	pAnalyzerThread->strTesterName_ = strTesterID;
	pAnalyzerThread->nTextCount_ = nTextCount;
	pAnalyzerThread->nGraphCount_ = nGraphcount;
	pAnalyzerThread->chartResourceID_ = nResourceID;


	CRect rect;

	::GetWindowRect(::GetDesktopWindow(), &rect);

	rect.left = ((rect.left*nSizeInPerc) / 100);
	rect.bottom = ((rect.bottom*nSizeInPerc) / 100);
	rect.top = ((rect.top*nSizeInPerc) / 100);
	rect.right = ((rect.right*nSizeInPerc) / 100);

	pAnalyzerThread->rect_ = rect;

	pAnalyzerThread->ResumeThread();

	CStAnalyzerThread::eventDialogCreated_.Lock();

	if (pAnalyzerThread->bDialogCreated_) {

		pAnalyzerThread->pDlg_->ShowWindow(SW_SHOW);
		pAnalyzerThread->pDlg_->SetFocus();
		pAnalyzerThread->pDlg_->SetForegroundWindow();

		//if (bCreateForeGround) {
		//	pAnalyzerThread->pDlg_->ShowWindow(SW_SHOW);
		//	pAnalyzerThread->pDlg_->SetFocus();
		//	pAnalyzerThread->pDlg_->SetForegroundWindow();
		//}
		//else {
		//	pAnalyzerThread->pDlg_->ShowWindow(SW_SHOWNOACTIVATE);
		//}
	}


	return 	pAnalyzerThread.release();
}

CStAnalyzerThread* CStAnalyzerThread::CreateAnalyzerThread(const std::string& strTestName, const std::string& strTesterID, CRect rect, int nTextCount, int nGraphcount, int nResourceID)
{
	std::auto_ptr<CStAnalyzerThread> pAnalyzerThread{ dynamic_cast<CStAnalyzerThread*>(AfxBeginThread(RUNTIME_CLASS(CStAnalyzerThread), THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED)) };

	if (!pAnalyzerThread.get()) {
		throw;
	}

	pAnalyzerThread->m_bAutoDelete = FALSE;
	pAnalyzerThread->strTestName_ = strTestName;
	pAnalyzerThread->strTesterName_ = strTesterID;
	pAnalyzerThread->nTextCount_ = nTextCount;
	pAnalyzerThread->nGraphCount_ = nGraphcount;
	pAnalyzerThread->chartResourceID_ = nResourceID;

	pAnalyzerThread->rect_ = rect;

	pAnalyzerThread->ResumeThread();

	CStAnalyzerThread::eventDialogCreated_.Lock();

	if (pAnalyzerThread->bDialogCreated_) {
		pAnalyzerThread->pDlg_->ShowWindow(SW_SHOW);
		pAnalyzerThread->pDlg_->SetFocus();
		pAnalyzerThread->pDlg_->SetForegroundWindow();
	}


	return 	pAnalyzerThread.release();

}



BOOL CStAnalyzerThread::InitInstance()
{
	// TODO:  perform and per-thread initialization here
	if (CoInitializeEx(NULL, COINIT_APARTMENTTHREADED) < 0)
	{
		return FALSE;
	}

	pDlg_.reset(new CStAnalyzerDlg(strTestName_.c_str(), strTesterName_.c_str(), NULL));

	BOOL bDialogCreated{ pDlg_->Create(CStAnalyzerDlg::IDD, NULL) };

	ASSERT(bDialogCreated == TRUE);

	pDlg_->text_control_count_ = nTextCount_;
	pDlg_->graph_control_count_ = nGraphCount_;
	pDlg_->m_nGraphResourceID = chartResourceID_;

	pDlg_->ShowWindow(SW_HIDE);
	pDlg_->UpdateWindow();
	pDlg_->MoveWindow(rect_);

	std::pair<int, int> pr;
	pr.first = nTextCount_;
	pr.second = nGraphCount_;
	pDlg_->SendMessage(UWM_CREATE_SUB_WINDOW, reinterpret_cast<WPARAM>(&bDialogCreated_), reinterpret_cast<LPARAM>(&pr));

	//////if (status)
	//////{
	//////	pDlg_->ShowWindow(SW_SHOW);
	//////	pDlg_->SetFocus();
	//////	pDlg_->SetForegroundWindow();
	//////}

	////m_pMainWnd = pDlg_.get();

	CStAnalyzerThread::eventDialogCreated_.SetEvent();

	return TRUE;
}

int CStAnalyzerThread::ExitInstance()
{
	// TODO:  perform any per-thread cleanup here
	TRACE(_T("\nCStAnalyzerThread::ExitInstance\n"));

	if (pDlg_.get()) {
		if (pDlg_->GetSafeHwnd()) {
			pDlg_->SendMessage(WM_CLOSE);
		}
	}

	CoUninitialize();

	return CWinThread::ExitInstance();
}

void CStAnalyzerThread::ResetDialogContent()
{
	std::unique_ptr<std::pair<int, int>> pr{ new std::pair<int, int> };
	pr->first = nTextCount_;
	pr->second = nGraphCount_;

	pDlg_->PostMessage(UWM_RESET_DLG_CONTENT, 0, reinterpret_cast<LPARAM>(pr.release()));

}


BEGIN_MESSAGE_MAP(CStAnalyzerThread, CWinThread)
	ON_THREAD_MESSAGE(WM_ANALYZER_THREAD_SET_FORCE_CLOSE, &CStAnalyzerThread::OnSetForceClose)
	ON_THREAD_MESSAGE(WM_ANALYZER_THREAD_RESET_DLG_CONTENT, &CStAnalyzerThread::OnResetDialogContent)
	ON_THREAD_MESSAGE(WM_ANALYZER_THREAD_SET_DIALOG_MENU, &CStAnalyzerThread::OnSetDialogMenu)
	ON_THREAD_MESSAGE(UWM_ANALYZER_THREAD_CALL_GRAPH_FUNCTION, &CStAnalyzerThread::OnGraphFunction)
	ON_THREAD_MESSAGE(UWM_ANALYZER_THREAD_PLOT_GIS_TEXT, &CStAnalyzerThread::OnPlotGISText)
END_MESSAGE_MAP()


// CStAnalyzerThread message handlers
void CStAnalyzerThread::OnSetForceClose(WPARAM wParam, LPARAM lParam)
{
	if (!pDlg_.get()) {
		return;
	}

	if (!pDlg_->GetSafeHwnd()) {
		return;
	}
	pDlg_->SendMessage(UWM_SET_CLOSE_MODE, wParam, lParam);
}

void CStAnalyzerThread::OnResetDialogContent(WPARAM wParam, LPARAM lParam)
{
	std::unique_ptr<std::pair<int, int>> pr{ new std::pair<int, int> };
	pr->first = nTextCount_;
	pr->second = nGraphCount_;

	pDlg_->PostMessage(UWM_RESET_DLG_CONTENT, wParam, reinterpret_cast<LPARAM>(pr.release()));
	//pDlg_->PostMessage(UWM_RESET_DLG_CONTENT, wParam, lParam);
}

void CStAnalyzerThread::OnSetDialogMenu(WPARAM wParam, LPARAM lParam)
{
	pDlg_->SendMessage(WM_SET_DIALOG_MENU, wParam, lParam);

}

void CStAnalyzerThread::OnGraphFunction(WPARAM wParam, LPARAM lParam)
{
	int nCommandID{ static_cast<int>(wParam) };

	std::auto_ptr<CStGIS_GraphData> pData{ reinterpret_cast<CStGIS_GraphData*>(lParam) };

	std::auto_ptr<CPlotGraphInfo> pPlotInfo{ new CPlotGraphInfo };

	switch (nCommandID)
	{

		case GIS_CLEARDATA:
			break;

		case GIS_SETAXIS:
		{
			pPlotInfo->gis_cmd_ = GIS_SETAXIS;
			pPlotInfo->nSequenceID_ = pData->m_nSequenceID;
			pPlotInfo->stObjProp_ = pData->m_stObjProp;
			pPlotInfo->nGraphDataType_ = pData->m_nGraphDataType;
		}
			break;

		case GIS_SETLINE:
		{
			pPlotInfo->gis_cmd_ = GIS_SETLINE;
			pPlotInfo->nSequenceID_ = pData->m_nSequenceID;
			pPlotInfo->stObjLine_ = pData->m_stObjLine;
			pPlotInfo->nGraphDataType_ = pData->m_nGraphDataType;
		}
			break;

		////case GIS_PLOTGRAPHSINGLE:
		////{								
		////	pPlotInfo->gis_cmd_ = GIS_PLOTGRAPHSINGLE;
		////	pPlotInfo->nSequenceID_ = pData->m_nSequenceID;

		////	if (pData->m_nGraphDataType == 10)
		////	{
		////		pPlotInfo->dXSingleXValue_ = pData->m_dXSingleXValue;
		////		pPlotInfo->dXSingleXY1Value_ = pData->m_dXSingleXY1Value;
		////		pPlotInfo->nLineColor_ = pData->m_nLineColor;
		////		pPlotInfo->nDataUpdateMode_ = pData->m_nDataUpdateMode;
		////		pPlotInfo->nGraphDataType_ = pData->m_nGraphDataType;
		////	}
		////	else if (pData->m_nGraphDataType == 16)
		////	{
		////		pPlotInfo->dXSingleXValue_ = pData->m_dXSingleXValue;
		////		pPlotInfo->dXSingleXY1Value_ = pData->m_dXSingleXY1Value;
		////		pPlotInfo->nXYColor_ = pData->m_nXYColor;
		////		pPlotInfo->nDataUpdateMode_ = pData->m_nDataUpdateMode;
		////		pPlotInfo->nGraphDataType_ = pData->m_nGraphDataType;
		////	}
		////	else
		////	{
		////		pPlotInfo->dXSingleXValue_ = pData->m_dXSingleXValue;
		////		pPlotInfo->dXSingleXY1Value_ = pData->m_dXSingleXY1Value;
		////		pPlotInfo->nDataUpdateMode_ = pData->m_nDataUpdateMode;
		////		pPlotInfo->nGraphDataType_ = pData->m_nGraphDataType;
		////	}
		////}
		////	break;

		////case GIS_PLOTGRAPHSINGLE2Y:
		////{
		////	pPlotInfo->gis_cmd_ = GIS_PLOTGRAPHSINGLE2Y;
		////	pPlotInfo->nSequenceID_ = pData->m_nSequenceID;


		////	if (pData->m_nGraphDataType == 11)
		////	{
		////		pPlotInfo->dXSingleXValue_ = pData->m_dXSingleXValue;
		////		pPlotInfo->dXSingleXY1Value_ = pData->m_dXSingleXY1Value;
		////		pPlotInfo->dXSingleXY2Value_ = pData->m_dXSingleXY2Value;
		////		pPlotInfo->nLineColor_ = pData->m_nLineColor;
		////		pPlotInfo->nLine2Color_ = pData->m_nLine2Color;
		////		pPlotInfo->nDataUpdateMode_ = pData->m_nDataUpdateMode;
		////		pPlotInfo->nGraphDataType_ = pData->m_nGraphDataType;
		////	}
		////	else if (pData->m_nGraphDataType == 17)
		////	{
		////		pPlotInfo->dXSingleXValue_ = pData->m_dXSingleXValue;
		////		pPlotInfo->dXSingleXY1Value_ = pData->m_dXSingleXY1Value;
		////		pPlotInfo->dXSingleXY2Value_ = pData->m_dXSingleXY2Value;
		////		pPlotInfo->nXYColor_ = pData->m_nXYColor;
		////		pPlotInfo->nXY2Color_ = pData->m_nXY2Color;
		////		pPlotInfo->nDataUpdateMode_ = pData->m_nDataUpdateMode;
		////		pPlotInfo->nGraphDataType_ = pData->m_nGraphDataType;
		////	}
		////	else
		////	{
		////		pPlotInfo->dXSingleXValue_ = pData->m_dXSingleXValue;
		////		pPlotInfo->dXSingleXY1Value_ = pData->m_dXSingleXY1Value;
		////		pPlotInfo->dXSingleXY2Value_ = pData->m_dXSingleXY2Value;
		////		pPlotInfo->nDataUpdateMode_ = pData->m_nDataUpdateMode;
		////		pPlotInfo->nGraphDataType_ = pData->m_nGraphDataType;
		////	}
		////}
		////	break;

		////case GIS_PLOTGRAPH1D:
		////{
		////	pPlotInfo->gis_cmd_ = GIS_PLOTGRAPH1D;
		////	pPlotInfo->nSequenceID_ = pData->m_nSequenceID;
		////	pPlotInfo->nGraphDataType_ = pData->m_nGraphDataType;

		////	if (pData->m_nGraphDataType == 12)
		////	{
		////		////pPlotInfo->vec_XAxisValues_ = pData->m_vec_XAxisValues;
		////		////pPlotInfo->vec_Y1AxisValues_ = pData->m_vec_Y1AxisValues;
		////		pPlotInfo->vec_XAxisValues_.swap(pData->m_vec_XAxisValues);
		////		pPlotInfo->vec_Y1AxisValues_.swap(pData->m_vec_Y1AxisValues);

		////		pPlotInfo->nLineColor_ = pData->m_nLineColor;
		////		pPlotInfo->nDataUpdateMode_ = pData->m_nDataUpdateMode;
		////	}
		////	else if (pData->m_nGraphDataType == 18)
		////	{
		////		////pPlotInfo->vec_XAxisValues_ = pData->m_vec_XAxisValues;
		////		////pPlotInfo->vec_Y1AxisValues_ = pData->m_vec_Y1AxisValues;
		////		pPlotInfo->vec_XAxisValues_.swap(pData->m_vec_XAxisValues);
		////		pPlotInfo->vec_Y1AxisValues_.swap(pData->m_vec_Y1AxisValues);
		////		pPlotInfo->nXYColor_ = pData->m_nXYColor;
		////		pPlotInfo->nDataUpdateMode_ = pData->m_nDataUpdateMode;
		////	}
		////	else
		////	{
		////		////pPlotInfo->vec_XAxisValues_ = pData->m_vec_XAxisValues;
		////		////pPlotInfo->vec_Y1AxisValues_ = pData->m_vec_Y1AxisValues;
		////		pPlotInfo->vec_XAxisValues_.swap(pData->m_vec_XAxisValues);
		////		pPlotInfo->vec_Y1AxisValues_.swap(pData->m_vec_Y1AxisValues);
		////		pPlotInfo->nDataUpdateMode_ = pData->m_nDataUpdateMode;
		////	}
		////}
		////	break;

		////case GIS_PLOTGRAPH1D2Y:
		////{
		////	pPlotInfo->gis_cmd_ = GIS_PLOTGRAPH1D2Y;
		////	pPlotInfo->nSequenceID_ = pData->m_nSequenceID;
		////	pPlotInfo->nGraphDataType_ = pData->m_nGraphDataType;
		////	if (pData->m_nGraphDataType == 13)
		////	{
		////		////pPlotInfo->vec_XAxisValues_ = pData->m_vec_XAxisValues;
		////		////pPlotInfo->vec_Y1AxisValues_ = pData->m_vec_Y1AxisValues;
		////		////pPlotInfo->vec_Y2AxisValues_ = pData->m_vec_Y2AxisValues;
		////		pPlotInfo->vec_XAxisValues_.swap(pData->m_vec_XAxisValues);
		////		pPlotInfo->vec_Y1AxisValues_.swap(pData->m_vec_Y1AxisValues);
		////		pPlotInfo->vec_Y2AxisValues_.swap(pData->m_vec_Y2AxisValues);

		////		pPlotInfo->nLineColor_ = pData->m_nLineColor;
		////		pPlotInfo->nLine2Color_ = pData->m_nLine2Color;
		////		pPlotInfo->nDataUpdateMode_ = pData->m_nDataUpdateMode;
		////	}
		////	else if (pData->m_nGraphDataType == 19)
		////	{
		////		////pPlotInfo->vec_XAxisValues_ = pData->m_vec_XAxisValues;
		////		////pPlotInfo->vec_Y1AxisValues_ = pData->m_vec_Y1AxisValues;
		////		////pPlotInfo->vec_Y2AxisValues_ = pData->m_vec_Y2AxisValues;
		////		pPlotInfo->vec_XAxisValues_.swap(pData->m_vec_XAxisValues);
		////		pPlotInfo->vec_Y1AxisValues_.swap(pData->m_vec_Y1AxisValues);
		////		pPlotInfo->vec_Y2AxisValues_.swap(pData->m_vec_Y2AxisValues);
		////		pPlotInfo->nXYColor_ = pData->m_nXYColor;
		////		pPlotInfo->nXY2Color_ = pData->m_nXY2Color;
		////		pPlotInfo->nDataUpdateMode_ = pData->m_nDataUpdateMode;
		////	}
		////	else
		////	{
		////		////pPlotInfo->vec_XAxisValues_ = pData->m_vec_XAxisValues;
		////		////pPlotInfo->vec_Y1AxisValues_ = pData->m_vec_Y1AxisValues;
		////		////pPlotInfo->vec_Y2AxisValues_ = pData->m_vec_Y2AxisValues;
		////		pPlotInfo->vec_XAxisValues_.swap(pData->m_vec_XAxisValues);
		////		pPlotInfo->vec_Y1AxisValues_.swap(pData->m_vec_Y1AxisValues);
		////		pPlotInfo->vec_Y2AxisValues_.swap(pData->m_vec_Y2AxisValues);
		////		pPlotInfo->nDataUpdateMode_ = pData->m_nDataUpdateMode;
		////	}
		////}
		////	break;

		////case GIS_PLOTGRAPH2D:
		////{
		////	pPlotInfo->gis_cmd_ = GIS_PLOTGRAPH2D;
		////	pPlotInfo->nSequenceID_ = pData->m_nSequenceID;
		////	pPlotInfo->nGraphDataType_ = pData->m_nGraphDataType;

		////	if (pData->m_nGraphDataType == 14)
		////	{
		////		////pPlotInfo->vec_XAxisValues_ = pData->m_vec_XAxisValues;
		////		////pPlotInfo->vec_2DY1AxisValues_ = pData->m_vec_2DY1AxisValues;
		////		pPlotInfo->vec_XAxisValues_.swap(pData->m_vec_XAxisValues);
		////		pPlotInfo->vec_2DY1AxisValues_.swap(pData->m_vec_2DY1AxisValues);
		////		pPlotInfo->nLineColor_ = pData->m_nLineColor;
		////		pPlotInfo->nDataUpdateMode_ = pData->m_nDataUpdateMode;
		////	}
		////	else if (pData->m_nGraphDataType == 20)
		////	{
		////		////pPlotInfo->vec_XAxisValues_ = pData->m_vec_XAxisValues;
		////		////pPlotInfo->vec_2DY1AxisValues_ = pData->m_vec_2DY1AxisValues;
		////		pPlotInfo->vec_XAxisValues_.swap(pData->m_vec_XAxisValues);
		////		pPlotInfo->vec_2DY1AxisValues_.swap(pData->m_vec_2DY1AxisValues);
		////		pPlotInfo->nXYColor_ = pData->m_nXYColor;
		////		pPlotInfo->nDataUpdateMode_ = pData->m_nDataUpdateMode;
		////	}
		////	else
		////	{
		////		////pPlotInfo->vec_XAxisValues_ = pData->m_vec_XAxisValues;
		////		////pPlotInfo->vec_2DY1AxisValues_ = pData->m_vec_2DY1AxisValues;
		////		pPlotInfo->vec_XAxisValues_.swap(pData->m_vec_XAxisValues);
		////		pPlotInfo->vec_2DY1AxisValues_.swap(pData->m_vec_2DY1AxisValues);
		////		pPlotInfo->nDataUpdateMode_ = pData->m_nDataUpdateMode;
		////	}
		////}
		////	break;

		case GIS_PLOTGRAPH2D2Y:
		{
			pPlotInfo->gis_cmd_ = GIS_PLOTGRAPH2D2Y;
			pPlotInfo->nSequenceID_ = pData->m_nSequenceID;
			pPlotInfo->nGraphDataType_ = pData->m_nGraphDataType;

			if (pData->m_nGraphDataType == 15)
			{
				////pPlotInfo->vec_XAxisValues_ = pData->m_vec_XAxisValues;
				////pPlotInfo->vec_2DY1AxisValues_ = pData->m_vec_2DY1AxisValues;
				////pPlotInfo->vec_2DY2AxisValues_ = pData->m_vec_2DY2AxisValues;
				pPlotInfo->vec_XAxisValues_.swap(pData->m_vec_XAxisValues);
				pPlotInfo->vec_2DY1AxisValues_.swap(pData->m_vec_2DY1AxisValues);
				pPlotInfo->vec_2DY2AxisValues_.swap(pData->m_vec_2DY2AxisValues);
				pPlotInfo->nLineColor_ = pData->m_nLineColor;
				pPlotInfo->nLine2Color_ = pData->m_nLine2Color;
				pPlotInfo->nDataUpdateMode_ = pData->m_nDataUpdateMode;
			}
			else if (pData->m_nGraphDataType == 21)
			{
				////pPlotInfo->vec_XAxisValues_ = pData->m_vec_XAxisValues;
				////pPlotInfo->vec_2DY1AxisValues_ = pData->m_vec_2DY1AxisValues;
				////pPlotInfo->vec_2DY2AxisValues_ = pData->m_vec_2DY2AxisValues;
				pPlotInfo->vec_XAxisValues_.swap(pData->m_vec_XAxisValues);
				pPlotInfo->vec_2DY1AxisValues_.swap(pData->m_vec_2DY1AxisValues);
				pPlotInfo->vec_2DY2AxisValues_.swap(pData->m_vec_2DY2AxisValues);
				pPlotInfo->nXYColor_ = pData->m_nXYColor;
				pPlotInfo->nXY2Color_ = pData->m_nXY2Color;
				pPlotInfo->nDataUpdateMode_ = pData->m_nDataUpdateMode;
			}
			else
			{
				////pPlotInfo->vec_XAxisValues_ = pData->m_vec_XAxisValues;
				////pPlotInfo->vec_2DY1AxisValues_ = pData->m_vec_2DY1AxisValues;
				////pPlotInfo->vec_2DY2AxisValues_ = pData->m_vec_2DY2AxisValues;
				pPlotInfo->vec_XAxisValues_.swap(pData->m_vec_XAxisValues);
				pPlotInfo->vec_2DY1AxisValues_.swap(pData->m_vec_2DY1AxisValues);
				pPlotInfo->vec_2DY2AxisValues_.swap(pData->m_vec_2DY2AxisValues);
				pPlotInfo->nDataUpdateMode_ = pData->m_nDataUpdateMode;
			}
		}
			break;

		default:
			break;
	}


	pDlg_->PostMessage(UWM_CALL_GRAPH_FUNCTION, 0, reinterpret_cast<LPARAM>(pPlotInfo.release()));
}

void CStAnalyzerThread::OnPlotGISText(WPARAM wParam, LPARAM lParam)
{
	int nCommandID{ static_cast<int>(wParam) };

	std::auto_ptr<CStGIS_TextData> pData{ reinterpret_cast<CStGIS_TextData*>(lParam) };

	std::auto_ptr<CPlotTextInfo> pPlotInfo(new CPlotTextInfo);

	/***************************************************************
	*  Based on the Command type ,  Call the respective functions
	GIS_CREATESUBWINDOW |GIS_OPENSUBWINDOW
	*	GIS_SETLINE | GIS_CLEARDATA
	GIS_ADDPLOTXY2D | GIS_SETAXIS
	*	GIS_SETAXISNAME2Y  | GIS_SETLINE1
	GIS_PLOTXY2Y | GIS_PLOTXYSINGLE
	*	GIS_PLOTXYSINGLED | GIS_PLOTXY
	GIS_PLOTXY1 | 	GIS_APPENDPLOTXY
	*	GIS_APPENDPLOTXY1

	* * *********************************************************/

	switch (nCommandID)
	{

		////case GIS_PLOTTEXTSINGLE:
		////{
		////	pPlotInfo->gis_type_ = GIS_PLOTTEXTSINGLE;
		////	pPlotInfo->sequenceID_ = pData->m_nSequenceID;
		////	pPlotInfo->paramName1_ = pData->m_vec_paramname[0];
		////	pPlotInfo->nSingleValue_ = pData->m_nSingleValues;
		////	pPlotInfo->nUpdateMode_ = pData->m_nUpdateMode;
		////}
		////	break;

		////case GIS_PLOTTEXTSINGLED:
		////{
		////	pPlotInfo->gis_type_ = GIS_PLOTTEXTSINGLED;
		////	pPlotInfo->sequenceID_ = pData->m_nSequenceID;
		////	pPlotInfo->paramName1_ = pData->m_vec_paramname[0];
		////	pPlotInfo->dSingleValue_ = pData->m_dSingleValues;
		////	pPlotInfo->nUpdateMode_ = pData->m_nUpdateMode;
		////}
		////	break;

		////case GIS_PLOTTEXT1D:
		////{
		////	for (size_t i = 0; i < pData->m_vec_2DValues.rows(); i++)
		////	{
		////		for (size_t j = 0; j < pData->m_vec_2DValues.cols(); j++)
		////		{
		////			pPlotInfo->temp_[i] = pData->m_vec_2DValues[i][j];
		////		}
		////	}
		////	pPlotInfo->gis_type_ = GIS_PLOTTEXT1D;
		////	pPlotInfo->sequenceID_ = pData->m_nSequenceID;
		////	pPlotInfo->paramName1_ = pData->m_vec_paramname[0];
		////	pPlotInfo->nUpdateMode_ = pData->m_nUpdateMode;
		////}
		////	break;

		////case GIS_PLOTTEXTTWO1D:
		////{
		////	for (size_t i = 0; i < pData->m_vec_2DValues.rows(); i++)
		////	{
		////		double dX1 = 0.0, dX2 = 0.0;
		////		for (size_t j = 0; j < pData->m_vec_2DValues.cols(); j++)
		////		{
		////			if (i % 2 == 0)
		////			{
		////				dX1 = pData->m_vec_2DValues[i][j];
		////				pPlotInfo->temp_[j] = dX1;
		////			}
		////			else if (i % 2 == 1)
		////			{
		////				dX2 = pData->m_vec_2DValues[i][j];
		////				pPlotInfo->temp1_[j] = dX2;
		////			}
		////		}
		////	}

		////	pPlotInfo->gis_type_ = GIS_PLOTTEXTTWO1D;
		////	pPlotInfo->sequenceID_ = pData->m_nSequenceID;
		////	pPlotInfo->paramName1_ = pData->m_vec_paramname[0];
		////	pPlotInfo->paramName2_ = pData->m_vec_paramname[1];
		////	pPlotInfo->nUpdateMode_ = pData->m_nUpdateMode;
		////}
		////	break;

		////case GIS_PLOTTEXTTHREE1D:
		////{
		////	for (size_t i = 0; i < pData->m_vec_2DValues.rows(); i++)
		////	{
		////		double dX1 = 0.0, dX2 = 0.0, dX3 = 0.0;
		////		for (size_t j = 0; j < pData->m_vec_2DValues.cols(); j++)
		////		{
		////			if (j == 0)
		////			{
		////				dX1 = pData->m_vec_2DValues[i][j];
		////			}
		////			else if (j == 1)
		////			{
		////				dX2 = pData->m_vec_2DValues[i][j];
		////			}
		////			else if (j == 2)
		////			{
		////				dX3 = pData->m_vec_2DValues[i][j];
		////			}
		////		}

		////		pPlotInfo->temp_[i] = dX1;
		////		pPlotInfo->temp1_[i] = dX2;
		////		pPlotInfo->temp2_[i] = dX3;
		////	}
		////	pPlotInfo->gis_type_ = GIS_PLOTTEXTTHREE1D;
		////	pPlotInfo->sequenceID_ = pData->m_nSequenceID;
		////	pPlotInfo->paramName1_ = pData->m_vec_paramname[0];
		////	pPlotInfo->paramName2_ = pData->m_vec_paramname[1];
		////	pPlotInfo->paramName3_ = pData->m_vec_paramname[2];
		////	pPlotInfo->nUpdateMode_ = pData->m_nUpdateMode;
		////}
		////	break;

		case GIS_PLOTTEXT2D:
		{
			pPlotInfo->gis_type_ = GIS_PLOTTEXT2D;
			pPlotInfo->sequenceID_ = pData->m_nSequenceID;
			pPlotInfo->paramName1_ = pData->m_vec_paramname[0];
			pPlotInfo->temp3_ = pData->m_vec_2DValues;
			pPlotInfo->nUpdateMode_ = pData->m_nUpdateMode;
		}
			break;

		default:
			break;
	}


	pDlg_->PostMessage(UWM_PLOT_GIS_TEXT, 0, reinterpret_cast<LPARAM>(pPlotInfo.release()));
}
